/*------------------------------------------------------/
/														/
/	Copyright 1997, Srgio Durte <smd@di.fct.unl.pt>	/
/													MODIFIED FOR LINUX 3/1999	/
/------------------------------------------------------*/


#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
#include <glide/glide.h>
/*#include <windows.h> -JW*/
#include <GL/glut.h>

#include "defines.h"
#include "mat.h"
/*#include "win.h" -JW*/
#include "hw.h"
#include "rgb.h"
#include "cam.h"
#include "tex.h"
#include "cell.h"

Float dt ;

Float Time = 0.0 ;
static Float absTime ;

static XYZ from, at, up ;
static Float  FP, BP, focus ;
static Bool all_created = False ;

char tex_path[ 512 ] ;

static void main_InitCamera()
{

//     printf("J: Enter InitCamera\n");
     from.x = 0.0 ;
     from.y = 0.0 ;
     from.z = -100.0 ;

     at.x = 0.0f ; at.y = 0.0f ; at.z = 0.0f ;
     up.x = 0.0f ; up.y = 1.0f ; up.z = 0.0f ;

     focus = 0.6 ;

     FP = 5.0 ;
     BP = 4000.0 ;

     cam_SetCamParameters( & from, & at, & up, focus, FP, BP ) ;
     cam_BuildCameraTransform() ;
//     printf("J: Exit InitCamera\n");
}
 
void main_InitModule( void )
{
     time_t timer ;
     int ret ;

 //    printf("J: Enter InitModule\n");

     /*if( ! GetEnvironmentVariable("VoodooLights_Texture_Path", tex_path, sizeof( tex_path ) ) ) -JW*/
     sprintf( tex_path, "./Textures") ;
	
     srand( time( & timer ) % RAND_MAX ) ;
	
     if( ! hw_InitHardware() ) 
     {	
          hw_ShutdownHardware() ;
          /*	win_MessageBox( 1, "Glide Init Error", "Trouble with 3DFX Graphics hardware." ) ; -JW*/
          printf("Trouble With the 3dfx Hardware\n");
     }

//     printf("J: InitModule 1\n");
     rgb_InitPalette() ;

//     printf("J: InitModule 2\n");
     main_InitCamera() ;
	
     /*absTime = 0.001 * GetCurrentTime() ;*/
     absTime=0.001 * (float) glutGet(GLUT_ELAPSED_TIME);

//     printf("J: InitModeule 3 absTime=%f \n",absTime);
     main_InitCamera() ;
     cell_InitModule() ;	

     grGlideShamelessPlug( Time < 10.0 ) ;
//     printf("J: Exit InitModule\n");    
}	

void main_MainLoop( void )
{	
     Cell **p ;
//     printf("J: Enter MainLoop\n");
     /*dt = 0.001 *  GetCurrentTime() - absTime ;*/
     dt = (0.001 * (float)glutGet(GLUT_ELAPSED_TIME))-absTime;
//     printf("J: MainLoop dt=%f\n",dt);
     absTime += dt ;
     Time += dt ;

     if( cam_NewCamera() ) cam_BuildCameraTransform() ;

     grGlideShamelessPlug( Time < 10.0 && hw_VoodooChipset() ) ;

     grBufferSwap( 3 ) ;
     grColorMask( FXTRUE, FXFALSE ) ;
     grBufferClear( 0x0, 0, 0 );

     cell_MainLoop() ;

     while( grBufferNumPending() > 2 ) ;
//     printf("J: Exit MainLoop 2\n");
}

int main()
{
     int keepgoing = 1;
     main_InitModule();
     while (keepgoing)
     {
          main_MainLoop();
          if (tlKbHit())
          {
               keepgoing = 0;
          }
     }
     hw_ShutdownHardware();
     return 0;
}

